<!DOCTYPE html>
<html>

	<head lang="es">
		<meta charset="utf-8">
		<title>Trabajo en grupo TG2</title>
		<link rel="stylesheet" href="style.css">
		<link href="https://fonts.googleapis.com/css?family=Oswald&display=swap" rel="stylesheet">
		<link href="https://fonts.googleapis.com/css?family=Caladea|Oswald&display=swap" rel="stylesheet">
	</head>

<body>
	<header class="encabezado" id="0">
		<h1>Desarrollo con Tecnologías Emergentes. Curso 2019-20<br>
			Trabajo TG2 del grupo M4<br>
			Titulo: TG2. Evaluar y comparar dos tecnologias emergentes</h1>
	</header>
	<nav>
		<div class="navegacion">
			<a href="#0" class="boton">TG1</a>
			<a href="#1" class="boton">1</a>
			<a href="#2" class="boton">2</a>
			<a href="#3" class="boton">3</a>
			<a href="#4" class="boton">4</a>
			<a href="#5" class="boton">5</a>
			<a href="#6" class="boton">6</a>
		</div>
		<ul>
			<li class="index"><a href="#1">1. Informacion general</a></li>
			<li class="index"><a href="#2">2. Descripcion de las tecnologias</a></li>
			<li class="index"><a href="#3">3. Criterios de comparacion</a></li>
			<li class="index"><a href="#4">4. Evaluacion de los criterios por categoria</a></li>
			<li class="index"><a href="#5">5. Comparacion de las tecnologias</a></li>
			<li class="index"><a href="#6">6. Recomendaciones</a></li>
		</ul>
	</nav>
	<main>
		<section class="seccion" id="1">
			<h2>1. Información general</h2>
			<h3>1.1 Autores</h3>
			<ul>
			</br>
				<li><b>Daniel Pérez Moreno | </b><i>(Coordinador)</i></li>
				<li><b>Jorge Berbel Ruiz</b></li>
				<li><b>Aarón Vicente Santos</b></li>
				<li><b>Daniel Díaz Fernández</b></li>
				<li><b>Miguel Ángel Benito</b></li>
			</ul>
			<h3>1.2 Proyecto Scrum y repositorio en GitLab</h3>
			<div class="enlace"><a href="https://gitlab.com/dte2020/t4/tg2" target="blank" >Trabajo Grupal 2 (Grupo 4)</a></div></br>
			<div class="enlace"><a href="https://gitlab.com/dte2020/t4/tg2/-/milestones/1" target="blank" >Milestone Final "TG2" (Grupo 4)</a></div>
			<h3>1.3 Burndown chart</h3>
			<p>Diagrama Burndown final del Sprint TG2.</p>
			<div class="milestone"><img src="images/Milestone.png"></div>
			<h3>1.4 Presentación del trabajo</h3>
			<p>Presentación del trabajo formato PPT</p>
			<div class="enlace"><a href="PythonWebFrameworks_2.pptx" target="blank" download>Presentacion
			</a></div>
		</section>
		<section class="seccion" id="2">
			<h2>2. Descripción de las tecnologias</h2>
			<h3>2.1 Descripción de Django</h3>
			<p>Django es un framework de desarrollo web de código abierto escrito en Python, respetando el patrón de diseño MVC 
				(Modelo-Vista-Controlador).</p> <br>
				Su función principal es simplificar la creación de sitios web complejos, enfatizando la reutilización, la conectividad 
				y la extensibilidad de componentes. Busca un desarrollo rápido y sigue el principio DRY (Don´t Repeat Yourself: evitar
				cualquier duplicado en el código).
				<div class="import_images"><img src="images/django_logo.png" alt="Flask Image"></div>
				<p class="foot"><i>Figura 1. Logo de Django. Fuente: https://www.edgica.com/expand-your-knowledge-python-django-framework/</i></p>
				<p>Características generales:</p><br>
			<ul>
				<li>Desarrollo rápido: Django se diseñó con la intención de crear una aplicación web en menos tiempo.</li>
				<li>Seguro: Django ayuda a los desarrolladores a evitar errores de seguridad comunes, como inyecciones SQL,
					cross-site scripting... Su sistema de autenticación de usuario ofrece una forma segura de gestionar cuentas y contraseñas.
				</li>
				<li>Escalable: Django es por naturaleza escalable, adaptándose a pequeños y grandes proyectos.</li>
				<li>Bien armado: Django incluye varios módulos y librerías que pueden ser usadas para manejar tareas de desarrollo web comunes.</li>
				<li>Código abierto: Django es gratis y puede ser descargado con código del repositorio público.</li>
				<li>Comunidad y apoyo: Django es uno de los frameworks más populares y cuenta con una inmensa comunidad de apoyo y canales
					para contactar y compartir. 
				</li>
				<br>
				<p>Características más específicas:</p><br>
				<li>Mapeador objeto-relacional.</li>
				<li>Aplicaciones que se pueden instalar en cualquier página gestionada con Django.</li>
				<li>API de base de datos robusta.</li>
				<li>Sistema de vistas genéricas que ahorran escribir lógica de algunas tareas comunes.</li>
				<li>Despachador de URLs basado en expresiones regulares.</li>
				<li>Sistema extensible de plantillas basado en etiquetas, permitiendo herencia.</li>
				<li>Soporte de internacionalización, con traducciones incorporadas de la interfaz de admninistración.</li>
				<li>Documentación incorporada accesible a través de la aplicación administrativa.</li>
				<br>
				<p>Paquetes populares para Django:</p><br>
				<li>Django-extensions: Ofrece extensiones como shell_plus (importa modelos automáticamente al proyecto).</li>
				<li>Django-allauth: Autenticación, registro y gestion de cuentas.</li>
				<li>Python-decouple: Separa configuraciones del entorno del código de la aplicación.</li>
				<li>Celery: Encolador de tareas largas y pesadas.</li>
				</ul>
			<h3>2.2 Descripción de Flask</h3>
			<p>Flask es un micro framework web escrito en el lenguaje Python. Se clasifica como un microframework 
			porque no requiere herramientas o bibliotecas particulares. No tiene capa de abstracción de base de datos, 
			validación de formularios, ni ningún otor componente donde bibliotecas de terceros brinden funciones comunes. 
			Sin embargo, Flask admite extensiones que pueden agregar características de la aplicación como si fuesen 
			propias de Flask, como el mapeo objeto-relación, manejo de carga u otras tecnologías de autenticación.</p>
			<div class="import_images"><img src="images/flask_image.png" alt="Flask Image"></div>
			<p class="foot"><i>Figura 2. Logo de Flask. Fuente: https://flask.palletsprojects.com/en/1.1.x/</i></p>
			<p>Flask ha sido concebido para facilitar el desarrollo de Aplicaciones Web bajo el patrón MVC. El patrón MVC 
			es una manera o una forma de trabajar que permite diferenciar y separar lo que es el modelo de datos 
			(los datos que van a tener la App que normalmente están guardados en BD), la vista (página HTML) y el controlador 
			(donde se gestiona las peticiones de la app web).</p>
			</br>
			<p>Las principales características de Flask son: </p>
			</br>
			<ul>
				<li>No necesita muchas extensiones y se puede desarrollar una App de forma ágil y rápida.</li>
				<li>Incluye un servidor web de desarrollo. Se pueden probar y ver los resultados sin la necesidad de establecer un auténtico servidor web.</li>
				<li>Tiene un depurador y soporte integrado para pruebas unitarias: Si tenemos algún error en el código que se está construyendo se puede depurar ese error y se puede ver los valores de las variables. Además está la posibilidad de integrar pruebas unitarias.</li>
				<li>Es compatible con: Python 3, WSGI (Wsig es un protocolo que utiliza los servidores web para servir las páginas web escritas en Python), Google App Engine (PaS y Cloud COMputing que sirve para desarrollar y albergar aplicaciones web).</li>
				<li>Posee un buen manejo de rutas. Cuando se trabaja con Apps Web hechas en Python se tiene el controlador que recibe todas las peticiones que hacen los clientes y se tienen que determinar que ruta está accediendo el cliente para ejecutar el código necesario.</li>
				<li>Soporta de manera nativa el uso de cookies seguras.</li>
				<li>Se pueden usar sesiones.</li>
				<li>No tiene mapeo de entidad relación, sin embargo se puede usar una extensión para añadir esta funcionalidad.</li>
				<li>Sirve para construir servicios web (como APIs REST) o aplicaciones de contenido estático.</li>
				<li>Es Open Source y opera bajo una licencia de BSD.</li>
				<li>Tiene una extensa documentación, código de GitHub, además de una lista de correos (a la que te suscribes y te informan de todas las actualizaciones).</li>
				<li>Tiene una buena curva de aprendizaje y se aprende muy rápido.</li>
				<li>Utiliza las plantillas Jinja.</li>
				<li>Tiene una gran extensionabilidad, permite añadir muchas extensiones en función de las necesidades.</li>
			</ul>
		</br>
			<p>Algunas extensiones soportadas por FLask son:</p>
	</br>
			<ul>
				<li>flask-script: Permite tener un comando de la línea de comando para manejar la aplicación.</li>
				<li>flask-Bootstrap: Hojas de estilo para la página.</li>
				<li>flask-WTF: Sirve para generar formularios de HTML con clases y objetos.</li>
				<li>flask-Sqlalchemy: Sirve para poder generar el modelo de datos.</li>
				<li>flask-login: Sirve para la autenticación de usuario y contraseña.</li>
			</ul>
		</section>
		<section class="seccion" id="3">
			<h2>3. Criterios de comparacion</h2>	
			<h3>3.1 Categoria A: Generales</h3>
			
			<h4>3.1.1 Criterio A.1: Licencia.</h4>
			<ul>
				<li>Nombre del criterio: Licencia.</li>
				<li>Descripcion: La tecnología posee un tipo específico de licencia.</li>
				<li>Tipo de valor: texto libre</li>
			</ul>
			
			<h4>3.1.2 Criterio A.2: Madurez de la tecnología.</h4>
			<ul>
				<li>Nombre del criterio: Madurez.</li>
				<li>Descripcion: La teconología posee un grado de madurez que nos permite saber si tenemos
				versiones más estables o actualizadas.</li>
				<li>Tipo de valor: texto libre</li>
			</ul>
			
			<h4>3.1.3 Criterio A.3: Desarrolladores.</h4>
			<ul>
				<li>Nombre del criterio: Desarrollador.</li>
				<li>Descripcion: La tecnología está desarrollada por ciertas personas o empresas.</li>
				<li>Tipo de valor: texto libre</li>
			</ul>
			
			<h4>3.1.4 Criterio A.4: Comunidad.</h4>
			<ul>
				<li>Nombre del criterio: Comunidad.</li>
				<li>Descripcion: La tecnología cuenta con una comunidad de usuarios que pueden ser activos.</li>
				<li>Tipo de valor: texto libre</li>
			</ul>
			
			<h4>3.1.5 Criterio A.5: Documentación sobre la tecnología.</h4>
			<ul>
				<li>Nombre del criterio: Documentación.</li>
				<li>Descripcion:Documentación o fuentes de información sobre las tecnologías.</li>
				<li>Tipo de valor: texto libre</li>
			</ul>
			
			<h4>3.1.6 Criterio A.6: Soporte y mantenimiento.</h4>
			<ul>
				<li>Nombre del criterio: Soporte y mantenimiento.</li>
				<li>Descripcion: La tecnología cuenta con la opción de soporte y mantenimiento del 
				equipo desarrollador.</li>
				<li>Tipo de valor: boolean</li>
			</ul>
			
			<h4>3.1.7 Criterio A.7: Idiomas.</h4>
			<ul>
				<li>Nombre del criterio: Idiomas.</li>
				<li>Descripcion: La información sobre la tecnología se encuentra en varios idiomas.</li>
				<li>Tipo de valor: texto libre</li>
			</ul>
			
			<h4>3.1.8 Criterio A.8: Popularidad de la tecnología.</h4>
			<ul>
				<li>Nombre del criterio: Popularidad.</li>
				<li>Descripcion: La tecnología es popular, basada en número de búsquedas, proyectos
				realizados, etc.</li>
				<li>Tipo de valor: numérico</li>
			</ul>
			
			<h4>3.1.9 Criterio A.9: Capacidad de pruebas unitarias.</h4>
			<ul>
				<li>Nombre del criterio: Pruebas unitarias.</li>
				<li>Descripcion:La tecnología tiene la capacidad de realizar pruebas unitarias con una
				mayor simplicidad y calidad.</li>
				<li>Tipo de valor: texto libre</li>
			</ul>
			
			<h4>3.1.10 Criterio A.10: Soporta el uso de cookies seguras.</h4>
			<ul>
				<li>Nombre del criterio: cookies seguras.</li>
				<li>Descripcion: La tecnología soporta el uso de cookies seguras.</li>
				<li>Tipo de valor: texto libre</li>
			</ul>
			
			<h4>3.1.11 Criterio A.11: Competitividad.</h4>
			<ul>
				<li>Nombre del criterio: Competitividad.</li>
				<li>Descripcion: La tecnología sigue creciendo y adaptándose a las necesidades de sus
				usuarios y proyectos.</li>
				<li>Tipo de valor: texto libre.</li>
			</ul>
			
			
			<h3>3.2 Categoria B: Compatibilidad.</h3>
			<h4>3.2.1 Criterio B.1: Soporte de WSGI</h4>
			<ul>
				<li>Nombre del criterio: WSGI</li>
				<li>Descripcion: La tecnología soporta WSGI (Web Server Gateway Interface).</li>
				<li>Tipo de valor: boolean</li>
			</ul>
			<h4>3.2.2 Criterio B.2: Soporte de Unicode.</h4>
			<ul>
				<li>Nombre del criterio: Soporte de Unicode.</li>
				<li>Descripcion: La tecnología permite la compatibilidad con Unicode.</li>
				<li>Tipo de valor: boolean</li>
			</ul>
			<h3>3.3 Categoria C: Implementación y desarrollo.</h3>
			
			<h4>3.3.1 Criterio C.1: Instalación.</h4>
			<ul>
				<li>Nombre del criterio:  Instalación.</li>
				<li>Descripcion: La instalación de la tecnología es más o menos sencilla.</li>
				<li>Tipo de valor: texto libre.</li>
			</ul>
			
			<h4>3.3.2 Criterio C.2: Líneas de código.</h4>
			<ul>
				<li>Nombre del criterio: Líneas de código.</li>
				<li>Descripcion: Líneas de código de la tecnología.</li>
				<li>Tipo de valor: numerico</li>
			</ul>
			
			<h4>3.3.3 Criterio C.3: Curva de aprendizaje.</h4>
			<ul>
				<li>Nombre del criterio:  Curva de aprendizaje.</li>
				<li>Descripcion: la tecnología tiene una mejor curva de aprendizaje.</li>
				<li>Tipo de valor: texto libre o numerico</li>
			</ul>
			
			<h4>3.3.4 Criterio C.4: Implementación de sockets.</h4>
			<ul>
				<li>Nombre del criterio: Sockets.</li>
				<li>Descripcion: La implementación de sockets conlleva un grado de dificultad mayor o menor.</li>
				<li>Tipo de valor: numérico</li>
			</ul>
			
			<h4>3.3.5 Criterio C.5: Combinación con otras herramientas.</h4>
			<ul>
				<li>Nombre del criterio: Combinación con otras herramientas.</li>
				<li>Descripcion: La tecnología se puede combinar de una manera sencilla con diversas 
				herramientas u otras tecnologías.</li>
				<li>Tipo de valor: numérico.</li>
			</ul>
			
			<h4>3.3.6 Criterio C.6: Lenguaje de programación.</h4>
			<ul>
				<li>Nombre del criterio:  Lenguaje de programación.</li>
				<li>Descripcion: La tecnología posee un lenguaje de programación.</li>
				<li>Tipo de valor: texto libre</li>
			</ul>
			
			<h3>3.4 Categoria D: Características técnicas.</h3>
			
			<h4>3.4.1 Criterio D.1.: Escalabilidad.</h4>
			<ul>
				<li>Nombre del criterio: Escalabilidad.</li>
				<li>Descripcion: Escalabilidad de la aplicación.</li>
				<li>Tipo de valor: numérico o texto libre</li>
			</ul>
			
			<h4>3.4.2 Criterio D.2.: Sistema de autenticación.</h4>
			<ul>
				<li>Nombre del criterio:  Sistema de autenticación.</li>
				<li>Descripcion: La tecnología posee un sistema de autenticación de calidad que permite crear la función del login.</li>
				<li>Tipo de valor: texto libre</li>
			</ul>
			
			<h4>3.4.3 Criterio D.3.: Organización de la estructura y código.</h4>
			<ul>
				<li>Nombre del criterio: Organización.</li>
				<li>Descripcion: La tecnología proporciona alguna herramienta de organización del código y optimización del tiempo.</li>
				<li>Tipo de valor: boolean o numérico.</li>
			</ul>
			
			<h4>3.4.4 Criterio D.4.: Calidad de los API’s REST.</h4>
			<ul>
				<li>Nombre del criterio: Calidad de los API’s REST.</li>
				<li>Descripcion: Calidad de los API’s REST que se realizan con la tecnología.</li>
				<li>Tipo de valor: numérico</li>
			</ul>
			
			<h4>3.4.5 Criterio D.5.: Complejidad de API’s REST.</h4>
			<ul>
				<li>Nombre del criterio: Complejidad de API’s REST.</li>
				<li>Descripcion: Cuando se crean los API’s REST conllevan un mayor o menor grado de complejidad.</li>
				<li>Tipo de valor: númérico</li>
			</ul>
			
			<h4>3.4.6 Criterio D.6.: Simplicidad.</h4>
			<ul>
				<li>Nombre del criterio: Simplicidad.</li>
				<li>Descripcion: La tecnología posee un grado de simplicidad o complejidad.</li>
				<li>Tipo de valor: numérico</li>
			</ul>
			
			<h4>3.4.7 Criterio D.7.: Bases de datos.</h4>
			<ul>
				<li>Nombre del criterio:  Bases de datos.</li>
				<li>Descripcion: La tecnología tiene algunas herramientas o funcionalidades para tratar, 
				implementar o gestionar bases de datos.</li>
				<li>Tipo de valor: numérico.</li>
			</ul>
			
			<h4>3.4.8 Criterio D.8.: Integración.</h4>
			<ul>
				<li>Nombre del criterio: Integración.</li>
				<li>Descripcion: La teconología se puede integrar fácilmente en la aplicación. </li>
				<li>Tipo de valor: boolean</li>
			</ul>
			
			<h4>3.4.9 Criterio D.9.: Calidad de la tecnología.</h4>
			<ul>
				<li>Nombre del criterio: Calidad.</li>
				<li>Descripcion: La tecnología posee un grado de calidad.</li>
				<li>Tipo de valor: numérico.</li>
			</ul>
			
			<h3>3.5 Categoria E: Rendimiento</h3>
			
			<h4>3.5.1 Criterio E.1: Manejo de Rutas.</h4>
			<ul>
				<li>Nombre del criterio: Manejo de rutas.</li>
				<li>Descripcion: La tecnología aplica o utiliza un buen manejo de rutas.</li>
				<li>Tipo de valor: numérico</li>
			</ul>
			
			<h4>3.5.2 Criterio E.2: Velocidad de ejecución.</h4>
			<ul>
				<li>Nombre del criterio: velocidad de ejecución.</li>
				<li>Descripcion: La velocidad de ejecución de la tecnología.</li>
				<li>Tipo de valor: numérico</li>
			</ul>

			<h4>3.5.3 Criterio E.3: Aplicaciones complejas.</h4>
			<ul>
				<li>Nombre del criterio: aplicaciones complejas.</li>
				<li>Descripcion: La tecnología esmás recomendable y está más enfocada para aplicaciones más grandes, 
				robustas y de mayor complejidad, como por ejemplo proyectos de gran tamaño.</li>
				<li>Tipo de valor: texto libre</li>
			</ul>
			
			<h4>3.5.4 Criterio E.4: Aplicaciones simples.</h4>
			<ul>
				<li>Nombre del criterio:  Aplicaciones simples.</li>
				<li>Descripcion: La tecnología es más recomendable y está más enfocada a aplicaciones 
				con una mayor simplicidad y para actividades no complejas como blogs o tiendas.</li>
				<li>Tipo de valor: texto libre.</li>
			</ul>
		</section>

		<section class="seccion" id="4">
			<h2>4. Evaluación de los Criterios por Categoría</h2>
			<h3>4.1 Evaluacion de los criterios - Django</h3>
			<table>
				<tr>
					<th>Criterio</th>
					<th>Evaluacion</th>
				</tr>
				<tr>
					<td>Criterio A.1: Licencia</td>
					<td>BSD License (Permiso para utilizar las librerias sin problemas mientras se mantenga el
					copyright)</td>
				</tr>
				<tr>
					<td>Criterio A.2: Madurez</td>
					<td>Sí, a lo largo del tiempo se actualiza sin problemas para mejor funcionamiento.</td>
				</tr>
				<tr>
					<td>Criterio A.3: Desarrollador</td>
					<td>Sí</td>
				</tr>
				<tr>
					<td>Criterio A.4: Comunidad</td>
					<td>Sí, https://www.djangoproject.com/community/</td>
				</tr>
				<tr>
					<td>Criterio A.5: Documentación</td>
					<td>Sí, disponible en inglés y español, además de muy extensa y compleja.</td>
				</tr>
				<tr>
					<td>Criterio A.6: Soporte y Mantenimiento</td>
					<td>Sí, proporcionado por el equipo de Desarrolladores.</td>
				</tr>
				<tr>
					<td>Criterio A.7: Idiomas</td>
					<td>Inglés principalmente, pero está disponible totalmente en español y varios idiomas más.</td>
				</tr>
				<tr>
					<td>Criterio A.8: Popularidad</td>
					<td>Sí, es el Framework más famoso de Python.</td>
				</tr>
				<tr>
					<td>Criterio A.9: Pruebas Unitarias</td>
					<td>Sí. es sencillo y de calidad.</td>
				</tr>
				<tr>
					<td>Criterio A.10: Cookies Seguras</td>
					<td>Sí, pero tienes que cambiar las opciones porque por defecto no están.</td>
				</tr>
				<tr>
					<td>Criterio A.11: Competitividad</td>
					<td>Sí, a cada año más.</td>
				</tr>
				<tr>
					<td>Criterio B.1: WSGI</td>
					<td>Sí, pero necesita usar Servidor Apache para utilizarlo.</td>
				</tr>
				<tr>
					<td>Criterio B.2: Soporte de Unicode</td>
					<td>Sí</td>
				</tr>
				<tr>
					<td>Criterio C.1: Instalación</td>
					<td>Sencilla y rápida</td>
				</tr>
				<tr>
					<td>Criterio C.2: Líneas de Coódigo</td>
					<td>Mayor cantidad de líneas de código que otros Frameworks.</td>
				</tr>
				<tr>
					<td>Criterio C.3: Curva de Aprendizaje</td>
					<td>Es una curva más lenta, ya que es más complejo.</td>
				</tr>
				<tr>
					<td>Criterio C.4: Sockets</td>
					<td>Sí, pero es más complejo implementarlo.</td>
				</tr>
				<tr>
					<td>Criterio C.5: Combinación de Otras Herramientas</td>
					<td>Sí, pero la combinación no es tan buena como con otros frameworks.</td>
				</tr>
				<tr>
					<td>Criterio C.6: Lenguaje de Programación</td>
					<td>Python</td>
				</tr>
				<tr>
					<td>Criterio D.1: Escalabilidad</td>
					<td>Es el Framework más escalable.</td>
				</tr>
				<tr>
					<td>Criterio D.2: Sistema de Autenticación</td>
					<td>Sí, lo tiene por defecto.</td>
				</tr>
				<tr>
					<td>Criterio D.3: Organización</td>
					<td>Sí</td>
				</tr>
				<tr>
					<td>Criterio D.4: Calidad de los API's REST</td>
					<td>Mayor calidad.</td>
				</tr>
				<tr>
					<td>Criterio D.5: Complejidad de API's REST</td>
					<td>Mayor complejidad.</td>
				</tr>
				</tr>
				<tr>
					<td>Criterio D.6: Simplicidad</td>
					<td>Menor simplicidad que otros frameworks.</td>
				</tr>
				</tr>
				<tr>
					<td>Criterio D.7: Base de Datos</td>
					<td>Si, tiene un panel de administración para gestionar bases de datos.</td>
				</tr>
				</tr>
				<tr>
					<td>Criterio D.8: Integración</td>
					<td>Sí</td>
				</tr>
				<tr>
					<td>Criterio D.9: Calidad</td>
					<td>Sí</td>
				</tr>
				<tr>
					<td>Criterio E.1: Manejo de Rutas</td>
					<td>Sí, pero no tiene un nivel tan alto como otros frameworks.</td>
				</tr>
				<tr>
					<td>Criterio E.2: Velocidad de Ejecución</td>
					<td>Sí, pero es menos eficiente y tiene menor velocidad que Flask.</td>
				</tr>
				<tr>
					<td>Criterio E.3: Aplicaciones Complejas</td>
					<td>Sí, para crear Aplicaciones Complejas es mejor la eleccion de Django.</td>
				</tr>
				<tr>
					<td>Criterio E.4: Aplicaciones Simples</td>
					<td>Sí, pero mejor elegir frameworks más ligeros como Flask.</td>
				</tr>
			</table>

			<p>Cuando hay una pequeña referencia a "frameworks" suele ser directamente a Flask. En las respuestas
			con un "sí" simple es porque no necesita mayor argumentación y se da a entender la relación del criterio
			con el resultado y evaluación.</p>
			

			<h3>4.2 Evaluacion de los criterios - Flask</h3>
			<table>
				<tr>
					<th>Criterio</th>
					<th>Evaluacion</th>
				</tr>
				<tr>
					<td>Criterio A.1: Licencia</td>
					<td>BSD License (Permiso para utilizar las librerias sin problemas mientras se mantenga el
					copyright)</td>
				</tr>
				<tr>
					<td>Criterio A.2: Madurez</td>
					<td>Aunque la última actualización es la 1.0.2  del 2 de mayo de 2018. Esta es una versión muy estable y de ahí la no actualización, por tanto validaremos su cumplimiento.</td>
				</tr>
				<tr>
					<td>Criterio A.3: Desarrollador</td>
					<td>Sí</td>
				</tr>
				<tr>
					<td>Criterio A.4: Comunidad</td>
					<td>Sí, https://dev.to/t/flask</td>
				</tr>
				<tr>
					<td>Criterio A.5: Documentación</td>
					<td>Sí, para distintos niveles, principiantes y avanzados.</td>
				</tr>
				<tr>
					<td>Criterio A.6: Soporte y Mantenimiento</td>
					<td>Sí, proporcionado por el equipo de Desarrolladores.</td>
				</tr>
				<tr>
					<td>Criterio A.7: Idiomas</td>
					<td>Desde la página oficial solo se puede encontrar en inglés</td>
				</tr>
				<tr>
					<td>Criterio A.8: Popularidad</td>
					<td>Sí, compite a la misma altura que Django en Python.</td>
				</tr>
				<tr>
					<td>Criterio A.9: Pruebas Unitarias</td>
					<td>Sí. es sencillo y de calidad.</td>
				</tr>
				<tr>
					<td>Criterio A.10: Cookies Seguras</td>
					<td>Sí, y facilmente editables</td>
				</tr>
				<tr>
					<td>Criterio A.11: Competitividad</td>
					<td>Sí, debido a sus altas prestaciones.</td>
				</tr>
				<tr>
					<td>Criterio B.1: WSGI</td>
					<td>Sí.</td>
				</tr>
				<tr>
					<td>Criterio B.2: Soporte de Unicode</td>
					<td>Sí</td>
				</tr>
				<tr>
					<td>Criterio C.1: Instalación</td>
					<td>Sencilla y rápida</td>
				</tr>
				<tr>
					<td>Criterio C.2: Líneas de Código</td>
					<td>Las lineas de código son inferiores a otros Frameworks ¡9 lineas un Hola mundo!.</td>
				</tr>
				<tr>
					<td>Criterio C.3: Curva de Aprendizaje</td>
					<td>Curva de aprendizaje poco pronunciada, recomendable usar este Framework en inicios de estudio.</td>
				</tr>
				<tr>
					<td>Criterio C.4: Sockets</td>
					<td>Muy fáciles de implementar mediante librerías.</td>
				</tr>
				<tr>
					<td>Criterio C.5: Combinación de Otras Herramientas</td>
					<td>Sí, fluida</td>
				</tr>
				<tr>
					<td>Criterio C.6: Lenguaje de Programación</td>
					<td>Python</td>
				</tr>
				<tr>
					<td>Criterio D.1: Escalabilidad</td>
					<td>Alta, debido a cientos de dependecias existentes.</td>
				</tr>
				<tr>
					<td>Criterio D.2: Sistema de Autenticación</td>
					<td>Sí, lo tiene por defecto.</td>
				</tr>
				<tr>
					<td>Criterio D.3: Organización</td>
					<td>Sí</td>
				</tr>
				<tr>
					<td>Criterio D.4: Calidad de los API's REST</td>
					<td>Calidad alta, pero no llega a la altura de Django.</td>
				</tr>
				<tr>
					<td>Criterio D.5: Complejidad de API's REST</td>
					<td>Menor complejidad.</td>
				</tr>
				</tr>
				<tr>
					<td>Criterio D.6: Simplicidad</td>
					<td>Posiblemente uno de los más sencillos.</td>
				</tr>
				</tr>
				<tr>
					<td>Criterio D.7: Base de Datos</td>
					<td>Si, tiene un panel de administración para gestionar bases de datos.</td>
				</tr>
				</tr>
				<tr>
					<td>Criterio D.8: Integración</td>
					<td>Sí</td>
				</tr>
				<tr>
					<td>Criterio D.9: Calidad</td>
					<td>Sí</td>
				</tr>
				<tr>
					<td>Criterio E.1: Manejo de Rutas</td>
					<td>Sí</td>
				</tr>
				<tr>
					<td>Criterio E.2: Velocidad de Ejecución</td>
					<td>Sí, Flask destaca en este aspecto.</td>
				</tr>
				<tr>
					<td>Criterio E.3: Aplicaciones Complejas</td>
					<td>Sí, pero necesita de muchas dependencias</td>
				</tr>
				<tr>
					<td>Criterio E.4: Aplicaciones Simples</td>
					<td>Sí, campo en el que destaca frente a la competencia.</td>
				</tr>
			</table>
		</section>

		<section class="seccion" id="5">
			<h2>5. Comparación de las tecnologías</h2>
			<p>A continuación, se presenta una comparación entre ambos frameworks. Es difícil concluir qué framework es mejor, ya que 
				aunque ambos se hicieron para el mismo campo (web development), se hicieron con propósitos diferentes. Dependiendo del tamaño 
				del proyecto o de la empresa, puede ser mejor usar uno u otro.</p>
			</p>
			<table>
				<tr>
					<th>Criterio</th>
					<th>Django</th>
					<th>Flask</th>
					<th>Comentarios</th>

				</tr>
				<tr>
					<td>A.1: Licencia</td>
					<td>BSD License.</td>
					<td>BSD License.</td>
					<td></td>
				</tr>
				<tr>
					<td>A.2: Madurez</td>
					<td>En constante actualización.</td>
					<td>Lleva sin actualizarse desde el 2 de mayo de 2018, pero sigue al nivel.</td>
					<td></td>
				</tr>
				<tr>
					<td>A.3: Desarrollador</td>
					<td>Django Software Foundation</td>
					<td>Armin Ronacher</td>
					<td></td>
				</tr>
				<tr>
					<td>A.4: Comunidad</td>
					<td>Amplia comunidad gracias a la característica OpenSource. Gran número de gente que contribuye al código base</td>
					<td>Amplia comunidad gracias a la característica OpenSource. Gran número de gente que contribuye al código base</td>
					<td></td>
				</tr>
				<tr>
					<td>A.5: Documentación</td>
					<td>Extensa y accesible desde la aplicación administrativa (incluye documentación generada automáticamente de modelos y bibliotecas añadidas)</td>
					<td>Buena, extensa y sencilla.</td>
					<td></td>
				</tr>
				<tr>
					<td>A.6: Soporte y Mantenimiento</td>
					<td>Sí</td>
					<td>Sí</td>
					<td>Ambos equipos de desarrolladores del framework proporcionan soporte, además de aquellos desarrolladores ajenos que son
						parte de la comunidad (gracias a foros, por ejemplo).
					</td>
				</tr>
				<tr>
					<td>A.7: Idiomas</td>
					<td>Inglés como principal, disponible en español y varios más.</td>
					<td>Inglés como principal.</td>
					<td></td>
				</tr>
				<tr>
					<td>A.8: Popularidad</td>
					<td>★★★★★</td>
					<td>★★★★★</td>
					<td>Ambos frameworks son muy populares, aunque Django aparece siempre como el número uno.</td>
				</tr>
				<tr>
					<td>A.9: Pruebas Unitarias</td>
					<td>Sencillas y de calidad</td>
					<td>Sencillas y de calidad.</td>
					<td></td>
				</tr>
				<tr>
					<td>A.10: Cookies Seguras</td>
					<td>Disponibles (hay que configurarlas)</td>
					<td>Sí. Fácilmente editables.</td>
					<td></td>
				</tr>
				<tr>
					<td>A.11: Competitividad</td>
					<td>Cada año más: Flask, web2py, TurboGears...</td>
					<td>Cada año más: Django, web2py, TurboGears...</td>
					<td>La única diferencia en cuanto a competitivdad, es que Django "lucha" por mantenerse, 
						mientras que Flask lo hace por mantenerse y por destronar a Django.</td>
				</tr>
				<tr>
					<td>B.1: WSGI</td>
					<td>Requiere de servidor Apache.</td>
					<td>Sí.</td>
					<td></td>
				</tr>
				<tr>
					<td>B.2: Soporte de Unicode.</td>
					<td>Sí.</td>
					<td>Sí.</td>
					<td></td>
				</tr>
				<tr>
					<td>C.1: Instalación</td>
					<td>Sencilla y rápida.</td>
					<td>Sencilla y rápida.</td>
					<td></td>
				</tr>
				<tr>
					<td>C.2: Líneas de Coódigo</td>
					<td>Cógido más denso en comparación con otros frameworks.</td>
					<td>Código ligero en general.</td>
					<td></td>
				</tr>
				<tr>
					<td>C.3: Curva de Aprendizaje</td>
					<td>Lenta pero remuneradora.</td>
					<td>Sencilla. Este framework es de los más recomendados para los iniciados en Python.</td>
					<td>La curva de Django es más complicada, pero porque ofrece más contenido que manejar también. Flask es un
						"micro" framework, y es perfecto para empezar a programar con Python, pues no hay mucho recorrido de aprendizaje
						en sus funciones.
					</td>
				</tr>
				<tr>
					<td>C.4: Sockets</td>
					<td>Implementación compleja.</td>
					<td>Implementación sencilla mediante librerías.</td>
					<td></td>
				</tr>
				<tr>
					<td>C.5: Combinación de Otras Herramientas</td>
					<td>Sí, pero no es destacable</td>
					<td>Sí, muy fluida.</td>
					<td>Aunque ambos pueden, Flask se combina mejor con herramientas como Jinja, SQLAlchemy...</td>
				</tr>
				<tr>
					<td>C.6: Lenguaje de Programación</td>
					<td>Python</td>
					<td>Python</td>
					<td></td>
				</tr>
				<tr>
					<td>D.1: Escalabilidad</td>
					<td>Alta. Se adapta a cualquier tamaño de proyecto gracias a su arquitectura "shared-nothing" 
						(cada parte de la arquitectura es independiente y se puede reemplazar)
					</td>
					<td>Alta.</td>
					<td>En el caso de Flask, puede verse limitada por temas como los proxies locales (no soportará el uso
						de concurrencias que no se basen en threads o greenlets).
					</td>
				</tr>
				<tr>
					<td>D.2: Sistema de Autenticación</td>
					<td>Cuenta con un sistema bastante potente.</td>
					<td>Cuenta con un sistema básico.</td>
					<td></td>
				</tr>
				<tr>
					<td>D.3: Organización</td>
					<td>Sí</td>
					<td>No</td>
					<td></td>
				</tr>
				<tr>
					<td>D.4: Calidad de los API's REST</td>
					<td>★★★★☆</td>
					<td>★★★☆☆</td>
					<td></td>
				</tr>
				<tr>
					<td>D.5: Complejidad de API's REST</td>
					<td>★★★★☆</td>
					<td>★★☆☆☆</td>
					<td></td>
				</tr>
				<tr>
					<td>D.6: Simplicidad</td>
					<td>★★☆☆☆</td>
					<td>★★★★★</td>
					<td>El diseño de Flask es minimalista y mucho más intuitivo que el de Django. Se debe tener en cuenta
						que Django se usa para proyectos más grandes.
					</td>
				</tr>
				<tr>
					<td>D.7: Base de Datos</td>
					<td>★★★★☆</td>
					<td>★★☆☆☆</td>
					<td>Django cuenta con un panel gestor de bases de datos, además de aceptar SQL y NoSQL. Flask simplemente tiene
						la posibilidad de implementar librerías con esas funciones.
					</td>
				</tr>
				<tr>
					<td>D.8: Integración</td>
					<td>Sí</td>
					<td>Sí</td>
					<td></td>
				</tr>
				<tr>
					<td>D.9: Calidad</td>
					<td>★★★★☆</td>
					<td>★★★★☆</td>
					<td></td>
				</tr>
				<tr>
					<td>E.1: Manejo de Rutas</td>
					<td>★★★☆☆</td>
					<td>★★★★☆</td>
					<td></td>
				</tr>
				<tr>
					<td>E.2: Velocidad de Ejecución</td>
					<td>★★★☆☆</td>
					<td>★★★★☆</td>
					<td></td>
				</tr>
				<tr>
					<td>E.3: Aplicaciones Complejas</td>
					<td>Se conoce como el mejor framework para añadir aplicaciones complejas.</td>
					<td>Se puede hacer pero se complica demasiado. Se necesitarían muchas dependencias
						para conseguirlo.
					</td>
					<td></td>
				</tr>
				<tr>
					<td>E.4: Aplicaciones Simples</td>
					<td>Se pueden añadir aplicaciones simples, pero hay mejores frameworks para estos propósitos.</td>
					<td>Se conoce como el mejor framework para añadir apliaciones simples.</td>
					<td></td>
				</tr>
			</table>
		</section>

		<section class="seccion" id="6">
			<h2>6. Recomendaciones</h2>
			<p> A continuación presentamos dos posibles situaciones donde se tiene que desarrollar algun tipo de aplicación / Software
				y es necesario implementarlo en lenguaje Python, para ello barajamos en ambas situaciones la tecnología 
				más adecuada para cada una de ellas en relación con las descritas y comparadas anteriormente:</p>
			<h3>6.1 Situacion A</h3>
			<h4>6.1.1 Descripcion de la situacion</h4>
			<p>En esta situación un grupo de estudiantes estan interesados en el desarrollo de una aplicación relacionada con las encuestas llamada THE QUIZ,
			   como requisitos aclaran que su objetivo principal es que esta aplicación sea fácil y rápida de programar, además deberá llevar implementado un sistema de cookies seguras además quieren llevar el listado de correos de la gente que
			   utilice la aplicación para poder enviar información de otros posibles lanzamientos, por último destacan que sólo admiten la programación mediante Python. "</p>
			<h4>6.1.2 Recomendacion de la tecnología a utilizar</h4>
			<p>Tras analizar esta situación, donde los alumnos por su experencia están capacitaos con conociminetos profundos sobre frameworks, y donde las especificaciones son tan claras, optaremos por Flask para el desarrolo</p>
			<p>Debe incluirse una tabla como la siguiente, mostrando las ventajas, respecto a los criterios, que ofrece
				cada tecnología en esa situacion concreta.</p>
			<p>Incluir solo los criterios sobre los que se aprecien ventajas de una de las tecnologías frente a otra. No
				incluir criterios que no sean relevantes para la decision (por ejemplo, el criterio “autor” seguramente
				no sera relevante).</p>
			</br>
			<p>Las principales ventajas que ofrece al grupo de estudiantes es:
			</p>
		</br>
		<ul>
				<li> Curva de aprendizaje muy plana, ideal para su situación.
				</li>
				
				<li> El código que hay que utilizar en el desarrollo de esta aplicación será mucho menor.
				</li>
				
				<li>Soporta de manera nativa el uso de cookies seguras.
				</li>
				
				<li> Buena documentación, código de GitHub y lista de correos.
			    </li>
		</ul>

			<h3>6.2 Situacion B</h3>
			<h4>6.2.1 Descripcion de la Situación</h4>
			<p> Un equipo de desarrolladores web están buscando un buen framework para una página web, la cual tenga un sistema
			de autenticación de usuarios eficaz y bueno. Tiene gran importancia que tenga una buena conexión con bases de datos
			externas, y que la información solo pueda ser controlada por los moderadores de la página. Lo más ideal a la hora
			de desarrollar esta página es que se utilice un Modelo Vista Controlador o Modelo Vista Plantilla. Los conocimiento de
			creación de páginas web con diferentes frameworks es alta y estos mismos expertos tienen experiencia y conocimiento sobre
			Python y diferentes lenguas orientadas al desarrollo de páginas Web y APIs de REST.
			</p>
			<h4>6.2.2 Recomendacion de la Tecnología a utilizar</h4>
			<p>Ante esta situación, donde el equipo de desarrolladores ya tienen un gran conocimiento y han obtenido un mayor
			conocimiento a lo largo del tiempo, no necesitan una "extensa" documentación, lo mejor para este caso es obtener
			material de apoyo para usuarios avanzados/expertos y que la aplicación ha de tener un Modelo Vista/Controlador,
			además de que se pueda hacer un sistema de autenticación bueno y fiable, con conexión a una base de datos mediana o grande.
			Para esto la mejor opción sería usar el Framework DJANGO.
			</p>
		</br>
			<p>Las principales ventajas que ofrece al equipo de desarrolladores web son:
			</p>
		</br>
		<ul>
				<li> Tutoriales y Cursos de Calidad tanto en español como en inglés para expertos.
				</li>
				
				<li> Django fue creado de por si para ser un Modelo Vista/Controlador.
				</li>
				
				<li> El propio Framework de Django cuenta con un sistema de autenticación de usuarios.
				</li>
				
				<li> Puede conectarse perfectamente con una base de datos grande y no daría problemas en la página web.
			    </li>
		</ul>
			<table>
				<tr>
					<th>Criterios relevantes para la decision</th>
					<th>Ventajas Tecnología 1 - Django</th>
					<th>Ventajas Tecnología 2 - Flask</th>
				</tr>
				<tr>
					<td>Material de Apoyo</td>
					<td>Tutoriales y Cursos de Calidad en español e inglés para expertos.</td>
					<td>Gran cantidad de cursos y tutoriales de aprendizaje rápido</td>					
				</tr>
				<tr>
					<td>Base de Datos</td>
					<td>Django tiene un gran soporte y administración para gestionar Base de Datos.</td>
					<td>No tiene un soporte o panel para las bases de datos sino que depende de librerías
					externas y diferentes aplicación que tengan esta funcionalidad.</td>
				</tr>
				<tr>
					<td>Sistema de Autenticación</td>
					<td>Django tiene un propio y muy bueno a la hora de funcionamiento.</td>
					<td>Depende de otras aplicaciones para tener un sistema de autenticación.</td>					
				</tr>
				<tr>
					<td>Versatilidad</td>
					<td>Django aparte de ser un Framework tambien es un Modelo Vista/Controlador, que le da más ventajas
					a la hora de desarrollar una página web.</td>
					<td>Flask tiene buena versatilidad pero no es un MVC como Django.</td>					
				</tr>

			</table>
		</section>
	</main>

</body>

</html>